/////////////////////////////////////////////////////////////////////////////
//
// DrivePickerListCtrl.h : header file for the drive selection list control.
//
// Written by Michael Dunn (mdunn at inreach dot com).  The method of the
// drive name/icon displaying logic comes from Wilfried Roemer's article 
// "A Drop-Down-Listbox for Drives" 
// (http://www.codeguru.com/combobox/DrvListBox.shtml).
//
// Comments/suggestions/bug reports/$20 bills are always welcome!
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_DRIVEPICKERLISTCTRL_H__A6D19CDC_00D7_11D3_8D3B_CEDE9540443D__INCLUDED_)
#define AFX_DRIVEPICKERLISTCTRL_H__A6D19CDC_00D7_11D3_8D3B_CEDE9540443D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


/////////////////////////////////////////////////////////////////////////////
// Flags used in CDrivePickerListCtrl::InitList()
// In case you're curious, "DDS" is my own prefix, and "DLIL" stands for
// Drive List Init List.

#define DDS_DLIL_HARDDRIVES 1   // hard drives
#define DDS_DLIL_CDROMS     2   // CD-ROM drives
#define DDS_DLIL_REMOVABLES 4   // other removable drives (floppy, Zip, etc.)
#define DDS_DLIL_NETDRIVES  8   // mapped network drives
#define DDS_DLIL_RAMDRIVES  16  // RAM drives

#define DDS_DLIL_ALL_REMOVABLE ( DDS_DLIL_CDROMS | DDS_DLIL_REMOVABLES )

#define DDS_DLIL_ALL_LOCAL_DRIVES ( DDS_DLIL_HARDDRIVES | DDS_DLIL_CDROMS | \
                                    DDS_DLIL_REMOVABLES | DDS_DLIL_RAMDRIVES )

#define DDS_DLIL_ALL_DRIVES ( DDS_DLIL_HARDDRIVES | DDS_DLIL_CDROMS | \
                              DDS_DLIL_REMOVABLES | DDS_DLIL_NETDRIVES | \
                              DDS_DLIL_RAMDRIVES )


/////////////////////////////////////////////////////////////////////////////
// CDrivePickerListCtrl window

class CDrivePickerListCtrl : public CListCtrl
{
// Construction
public:
	CDrivePickerListCtrl();

// Attributes
public:

// Operations
public:
    void InitList ( int nIconSize, DWORD dwFlags );

    void  SetSelection ( const DWORD dwDrives );
    void  SetSelection ( LPCTSTR szDrives );

    BYTE  GetNumSelectedDrives() const;
    void  GetSelectedDrives ( DWORD* pdwSelectedDrives ) const;
    void  GetSelectedDrives ( LPTSTR szSelectedDrives ) const;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDrivePickerListCtrl)
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
    virtual ~CDrivePickerListCtrl();

protected:
    CImageList  m_ImgList;

    void CommonInit ( BOOL bUseLargeIcons, DWORD dwFlags );

	// Generated message map functions
protected:
	//{{AFX_MSG(CDrivePickerListCtrl)
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DRIVEPICKERLISTCTRL_H__A6D19CDC_00D7_11D3_8D3B_CEDE9540443D__INCLUDED_)
